/*
 * ADLGraphPanel.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.adl;

import com.markuspage.markus.tbn.module1.AbstractTopMultiViewPanel;
import com.markuspage.markus.tbn.module1.CommentUtils;
import com.markuspage.markus.tbn.module1.adl.model.Binding;
import com.markuspage.markus.tbn.module1.adl.model.Channel;
import com.markuspage.markus.tbn.module1.adl.model.Component;
import com.markuspage.markus.tbn.module1.adl.model.Factory;
import com.markuspage.markus.tbn.module1.adl.model.Subscription;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.ArrayList;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import org.netbeans.api.visual.action.ActionFactory;
import org.netbeans.api.visual.action.ConnectProvider;
import org.netbeans.api.visual.action.ConnectorState;
import org.netbeans.api.visual.action.MoveProvider;
import org.netbeans.api.visual.action.MoveStrategy;
import org.netbeans.api.visual.action.PopupMenuProvider;
import org.netbeans.api.visual.action.TextFieldInplaceEditor;
import org.netbeans.api.visual.action.WidgetAction;
import org.netbeans.api.visual.anchor.AnchorFactory;
import org.netbeans.api.visual.anchor.AnchorShapeFactory;
import org.netbeans.api.visual.border.Border;
import org.netbeans.api.visual.border.BorderFactory;
import org.netbeans.api.visual.layout.LayoutFactory;
import org.netbeans.api.visual.model.ObjectState;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LabelWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.Widget;
import org.openide.util.Exceptions;

/**
 *
 * @author  markus
 */
public class ADLGraphPanel extends AbstractTopMultiViewPanel {

    private ADLDataObject dObj;
    private Scene scene = new Scene();
    private int x = 20,  y = 130;
    private LayerWidget mainLayerWidget;
    private LayerWidget connectionLayerWidget;

    public ADLGraphPanel(ADLDataObject dObj) {
        this.dObj = dObj;
        initComponents();
        initScene();
    }

    public JComponent getToolbarComponent() {
        return jToolBar1;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jToolBar1 = new javax.swing.JToolBar();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jButtonAddComponent = new javax.swing.JButton();
        jButtonAddChannel = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jButtonZoomIn = new javax.swing.JButton();
        jButtonZoomOut = new javax.swing.JButton();
        graphPane = new javax.swing.JScrollPane();

        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);
        jToolBar1.add(jSeparator1);

        jButtonAddComponent.setText(org.openide.util.NbBundle.getMessage(ADLGraphPanel.class, "ADLGraphPanel.jButtonAddComponent.text")); // NOI18N
        jButtonAddComponent.setFocusable(false);
        jButtonAddComponent.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonAddComponent.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonAddComponent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddComponentActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonAddComponent);

        jButtonAddChannel.setText(org.openide.util.NbBundle.getMessage(ADLGraphPanel.class, "ADLGraphPanel.jButtonAddChannel.text")); // NOI18N
        jButtonAddChannel.setFocusable(false);
        jButtonAddChannel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonAddChannel.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonAddChannel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddChannelActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonAddChannel);
        jToolBar1.add(jSeparator2);

        jButtonZoomIn.setText(org.openide.util.NbBundle.getMessage(ADLGraphPanel.class, "ADLGraphPanel.jButtonZoomIn.text")); // NOI18N
        jButtonZoomIn.setFocusable(false);
        jButtonZoomIn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonZoomIn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonZoomIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomInActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonZoomIn);

        jButtonZoomOut.setText(org.openide.util.NbBundle.getMessage(ADLGraphPanel.class, "ADLGraphPanel.jButtonZoomOut.text")); // NOI18N
        jButtonZoomOut.setFocusable(false);
        jButtonZoomOut.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonZoomOut.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonZoomOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomOutActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonZoomOut);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(graphPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(graphPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void jButtonAddComponentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddComponentActionPerformed
        addComponentActionPerformed();
}//GEN-LAST:event_jButtonAddComponentActionPerformed

    private void jButtonAddChannelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddChannelActionPerformed
        addChannelActionPerformed();
}//GEN-LAST:event_jButtonAddChannelActionPerformed

    private void jButtonZoomInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomInActionPerformed
        try {
            scene.setZoomFactor(scene.getZoomFactor() + 0.1);
            scene.validate();
            CommentUtils.saveZoomFactor(dObj.getConfiguration(), scene.getZoomFactor());
            dObj.modelUpdatedFromUI();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_jButtonZoomInActionPerformed

    private void jButtonZoomOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomOutActionPerformed
        try {
            double zoom = scene.getZoomFactor() - 0.1;
            if (zoom < 0.1) {
                zoom = 0.1;
            }
            scene.setZoomFactor(zoom);
            scene.validate();
            CommentUtils.saveZoomFactor(dObj.getConfiguration(), zoom);
            dObj.modelUpdatedFromUI();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_jButtonZoomOutActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JScrollPane graphPane;
    private javax.swing.JButton jButtonAddChannel;
    private javax.swing.JButton jButtonAddComponent;
    private javax.swing.JButton jButtonZoomIn;
    private javax.swing.JButton jButtonZoomOut;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables


    public void reload() {
        initScene();
    }

    private void initScene() {
        scene = new Scene();

        scene.setLayout(LayoutFactory.createAbsoluteLayout());
        mainLayerWidget = new LayerWidget(scene) {

            @Override
            protected void notifyStateChanged(ObjectState arg0, ObjectState arg1) {

                System.out.println("stateChanged from " + arg0 + " to " + arg1);
            }
        };
        scene.addChild(mainLayerWidget);
        connectionLayerWidget = new LayerWidget(scene) {

            @Override
            protected void notifyStateChanged(ObjectState arg0, ObjectState arg1) {

                System.out.println("stateChanged from " + arg0 + " to " + arg1);
            }
        };
        scene.addChild(connectionLayerWidget);

        scene.getActions().addAction(ActionFactory.createZoomAction());

        try {
            Double zoom = CommentUtils.getZoomFactor(dObj.getConfiguration());
            if (zoom == null) {
                zoom = 1.0;
            }
            scene.setZoomFactor(zoom);

            // Add all components
            for (Component component : dObj.getConfiguration().getComponents().getComponent()) {
                addComponentToScene(component);
            }

            // Add all channels
            for (Channel component : dObj.getConfiguration().getChannels().getChannel()) {
                addChannelToScene(component);
            }

            // Setup bindings
            for (Binding binding : dObj.getConfiguration().getBindings().getBinding()) {

                ComponentWidget wSrcComponent = findWidgetByComponentName(binding.getComponentName());
                ChannelWidget wDstChannel = findWidgetByChannelName(binding.getChannelName());

                addBinding(binding, wSrcComponent, wDstChannel);
            }

            // Setup subscriptions
            for (Subscription subscription : dObj.getConfiguration().getSubscriptions().getSubscription()) {

                ChannelWidget wSrcChannel = findWidgetByChannelName(subscription.getChannelName());
                ComponentWidget wDstComponent = findWidgetByComponentName(subscription.getComponentName());

                addSubscription(subscription, wSrcChannel, wDstComponent);
            }

            graphPane.setViewportView(scene.createView());
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private void addComponentActionPerformed() {

        String componentName = JOptionPane.showInputDialog("New component name");
        String factoryName = componentName + "Factory";

        if (existsFactory(factoryName) || existsComponent(factoryName, componentName)) {
            System.out.println("Component or Factory already exists");
            return;
        }

        // Add new factory
        Factory newFactory = new Factory();
        newFactory.setComponentClass("package." + componentName);
        newFactory.setFactoryName(factoryName);

        // Add new component
        Component newComponent = new Component();
        newComponent.setComponentName(componentName);
        newComponent.setFactoryName(factoryName);


        try {
            dObj.getConfiguration().getFactories().addFactory(newFactory);
            dObj.getConfiguration().getComponents().addComponent(newComponent);

            // Add to startup sequence
            dObj.getConfiguration().getStartSequence().getStartComponents().addComponentName(factoryName + ":" + componentName);

        } catch (IOException ex) {
            ex.printStackTrace();
        }
        dObj.modelUpdatedFromUI();

        Widget newWidget = addComponentToScene(newComponent);
        scene.validate();
        newWidget.repaint();
    }

    private void addChannelActionPerformed() {
        String channelName = JOptionPane.showInputDialog("New channel name");

        if (existsChannel(channelName)) {
            System.out.println("Channel already exists");
            return;
        }

        // Add new channel
        Channel newChannel = new Channel();
        newChannel.setChannelName(channelName);
        newChannel.setEventClass(new String[]{"sampleEvent"});

        try {
            dObj.getConfiguration().getChannels().addChannel(newChannel);

            // Add to startup sequence
            dObj.getConfiguration().getStartSequence().getStartChannels().addChannelName(channelName);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        dObj.modelUpdatedFromUI();

        Widget newWidget = addChannelToScene(newChannel);
        scene.validate();
        newWidget.repaint();
    }

    private void menuRemoveActionPerformed(Widget widget) {
        System.out.println("Remove " + widget);

        if (widget instanceof BindingWidget) {
            BindingWidget l = (BindingWidget) widget;
            Binding removeNode = l.getBinding();
            try {
                dObj.getConfiguration().getBindings().removeBinding(removeNode);
                dObj.modelUpdatedFromUI();
                connectionLayerWidget.removeChild(widget.getParentWidget());
                scene.validate();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        } else if (widget instanceof SubscriptionWidget) {
            SubscriptionWidget l = (SubscriptionWidget) widget;
            Subscription removeNode = l.getSubscription();
            try {
                dObj.getConfiguration().getSubscriptions().removeSubscription(removeNode);
                dObj.modelUpdatedFromUI();
                connectionLayerWidget.removeChild(widget.getParentWidget());
                scene.validate();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        } else if (widget instanceof ChannelWidget) {
            ChannelWidget l = (ChannelWidget) widget;
            Channel removeChannel = l.getChannel();

            // Check bindings and subscription
            if (hasChannelBindings(removeChannel.getChannelName()) ||
                    hasChannelSubscriptions(removeChannel.getChannelName())) {
                JOptionPane.showMessageDialog(null, "Remove bindings and subscriptions first");
                return;
            }

            // Remove channel
            try {
                dObj.getConfiguration().getChannels().removeChannel(removeChannel);

                // Remove from start sequence
                dObj.getConfiguration().getStartSequence().getStartChannels().removeChannelName(removeChannel.getChannelName());

                dObj.modelUpdatedFromUI();
                mainLayerWidget.removeChild(widget);
                scene.validate();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }

        } else if (widget instanceof ComponentWidget) {
            ComponentWidget l = (ComponentWidget) widget;
            Component removeComponent = l.getComponent();

            // Check bindings and subscription
            if (hasComponentBindings(removeComponent.getFactoryName(), removeComponent.getComponentName()) ||
                    hasComponentSubscriptions(removeComponent.getFactoryName(), removeComponent.getComponentName())) {
                JOptionPane.showMessageDialog(null, "Remove bindings and subscriptions first");
                return;
            }

            // Remove factory
            try {
                for (Factory f : dObj.getConfiguration().getFactories().getFactory()) {
                    if (f.getFactoryName().equals(removeComponent.getFactoryName())) {

                        dObj.getConfiguration().getFactories().removeFactory(f);
                        dObj.modelUpdatedFromUI();
                        break;
                    }
                }
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }


            try {
                // Remove from start sequence
                dObj.getConfiguration().getStartSequence().getStartComponents().removeComponentName(removeComponent.getFactoryName() + ":" + removeComponent.getComponentName());

                // Remove component
                dObj.getConfiguration().getComponents().removeComponent(removeComponent);

                dObj.modelUpdatedFromUI();
                mainLayerWidget.removeChild(widget);
                scene.validate();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private boolean hasChannelBindings(String channelName) {
        try {
            for (Binding b : dObj.getConfiguration().getBindings().getBinding()) {
                if (b.getChannelName().equals(channelName)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private boolean hasChannelSubscriptions(String channelName) {
        try {
            for (Subscription b : dObj.getConfiguration().getSubscriptions().getSubscription()) {
                if (b.getChannelName().equals(channelName)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private boolean hasComponentBindings(String factoryName, String componentName) {
        try {
            for (Binding b : dObj.getConfiguration().getBindings().getBinding()) {
                if (b.getComponentName().equals(factoryName + ":" + componentName)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private boolean hasComponentSubscriptions(String factoryName, String componentName) {
        try {
            for (Subscription b : dObj.getConfiguration().getSubscriptions().getSubscription()) {
                if (b.getChannelName().equals(factoryName + ":" + componentName)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private Widget addComponentToScene(Component node) {

        ComponentWidget nodeWidget = new ComponentWidget(scene, node);

        // Set location
        Point location = CommentUtils.getLocation(node);
        if (location != null) {
            nodeWidget.setPreferredLocation(location);
        } else {
            nodeWidget.setPreferredLocation(new Point(x, y));
        }

        mainLayerWidget.addChild(nodeWidget);

        // Update for next position
        x += 150;
        y += 20;
        if (x > 400 && x <= 590) {
            x += 150;
        }
        if (x >= 670) {
            y += 80;
            x = 20;
        }
        return nodeWidget;
    }

    private Widget addChannelToScene(Channel node) {

        ChannelWidget nodeWidget = new ChannelWidget(scene, node);


        Point location = CommentUtils.getLocation(node);
        if (location != null) {
            nodeWidget.setPreferredLocation(location);
        } else {
            nodeWidget.setPreferredLocation(new Point(x, y));
        }

        mainLayerWidget.addChild(nodeWidget);

        // Update for next position
        x += 150;
        y += 20;
        if (x > 400 && x <= 590) {
            x += 150;
        }
        if (x >= 670) {
            y += 80;
            x = 20;
        }
        return nodeWidget;
    }

    private void addBinding(Binding link, ComponentWidget wSrcComponent, ChannelWidget wDstChannel) {
        ConnectionWidget connectionWidget = new ConnectionWidget(scene);
        connectionWidget.setSourceAnchor(AnchorFactory.createRectangularAnchor(wSrcComponent));
        connectionWidget.setTargetAnchor(AnchorFactory.createRectangularAnchor(wDstChannel));
        connectionWidget.setTargetAnchorShape(AnchorShapeFactory.createArrowAnchorShape(40, 10));
        connectionWidget.setForeground(Color.BLUE);
        BindingWidget label = new BindingWidget(scene, link, wSrcComponent, wDstChannel);
        connectionWidget.addChild(label);
        connectionWidget.setConstraint(label, LayoutFactory.ConnectionWidgetLayoutAlignment.CENTER, 50);
        connectionLayerWidget.addChild(connectionWidget);
        scene.validate();
    }

    private void addSubscription(Subscription link, ChannelWidget wSrcChannel, ComponentWidget wDstComponent) {
        ConnectionWidget connectionWidget = new ConnectionWidget(scene);
        connectionWidget.setSourceAnchor(AnchorFactory.createRectangularAnchor(wSrcChannel));
        connectionWidget.setTargetAnchor(AnchorFactory.createRectangularAnchor(wDstComponent));
        connectionWidget.setTargetAnchorShape(AnchorShapeFactory.createArrowAnchorShape(40, 10));
        connectionWidget.setForeground(Color.GREEN);
        SubscriptionWidget label = new SubscriptionWidget(scene, link, wSrcChannel, wDstComponent);
        connectionWidget.addChild(label);
        connectionWidget.setConstraint(label, LayoutFactory.ConnectionWidgetLayoutAlignment.CENTER, 50);
        connectionLayerWidget.addChild(connectionWidget);
        scene.validate();
    }

    private ComponentWidget findWidgetByComponentName(String componentName) {

        String[] name = componentName.split(":");
        String factory = name[0];
        String component = name[1];

        for (Widget w : mainLayerWidget.getChildren()) {

            if (w instanceof ComponentWidget) {
                ComponentWidget n = (ComponentWidget) w;
                if (factory.equals(n.getComponent().getFactoryName()) &&
                        component.equals(n.getComponent().getComponentName())) {
                    return n;
                }
            }
        }
        System.out.println("null");
        return null;
    }

    private ChannelWidget findWidgetByChannelName(String channelName) {

        for (Widget w : mainLayerWidget.getChildren()) {

            if (w instanceof ChannelWidget) {
                ChannelWidget n = (ChannelWidget) w;
                if (channelName.equals(n.getChannel().getChannelName())) {
                    return n;
                }
            }
        }
        System.out.println("null");
        return null;
    }

    private void saveLocations() {
        for (Widget w : mainLayerWidget.getChildren()) {
            if (w instanceof ComponentWidget) {
                ComponentWidget c = (ComponentWidget) w;

                CommentUtils.saveLocation(c.getComponent(), c.getLocation());
            } else if (w instanceof ChannelWidget) {
                ChannelWidget c = (ChannelWidget) w;

                CommentUtils.saveLocation(c.getChannel(), c.getLocation());
            }
        }
    }

    private class ComponentWidget extends Widget implements TextFieldInplaceEditor {

        private Component node;
        private LabelWidget factoryWidget;
        private LabelWidget componentWidget;
        private Widget connectWidget;
        private Border standardBorder = BorderFactory.createRoundedBorder(40, 40, 3, 3, new Color(153, 153, 255), Color.BLACK);
        private Border subBorder = BorderFactory.createRoundedBorder(10, 10, 3, 3, new Color(153, 153, 255), Color.GRAY);
        private static final int WIDTH = 100;
        private static final int HEIGHT = 80;
        private WidgetAction nodeMenuAction;
        private JPopupMenu menu;

        public ComponentWidget(Scene scene, Component node) {
            super(scene);
            this.node = node;

            menu = new JPopupMenu("Component popup menu");
            JMenuItem item;
            item = new JMenuItem("Add new component");
            item.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    addComponentActionPerformed();
                }
            });
            menu.add(item);
            item = new JMenuItem("Remove component");
            item.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    menuRemoveActionPerformed(ComponentWidget.this);
                }
            });
            menu.add(item);

            initWidget();
        }

        private void initWidget() {
            componentWidget = new LabelWidget(scene, node.getComponentName());
            factoryWidget = new LabelWidget(scene, node.getFactoryName());
            connectWidget = new Widget(scene);

            addChild(factoryWidget);
            addChild(componentWidget);
            addChild(connectWidget);

            setBorder(standardBorder);
            setPreferredSize(new Dimension(WIDTH, HEIGHT));

            getActions().addAction(ActionFactory.createMoveAction(new MoveStrategy() {

                public Point locationSuggested(Widget widget, Point originalLocation, Point suggestedLocation) {
                    return suggestedLocation;
                }
            }, new MoveProvider() {

                public void movementStarted(Widget arg0) {
                }

                public void movementFinished(Widget arg0) {
                    saveLocations();
                    dObj.modelUpdatedFromUI();
                }

                public Point getOriginalLocation(Widget arg0) {
                    return arg0.getLocation();
                }

                public void setNewLocation(Widget arg0, Point arg1) {
                    arg0.setPreferredLocation(arg1);
                }
            }));

            //factoryWidget.setBorder(subBorder);
            factoryWidget.setPreferredLocation(new Point(0, 20));
            factoryWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            factoryWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            //componentWidget.setBorder(subBorder);
            componentWidget.setPreferredLocation(new Point(0, 40));
            componentWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            componentWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            connectWidget.setBorder(subBorder);
            connectWidget.setPreferredLocation(new Point(6, 60));
            connectWidget.setPreferredSize(new Dimension(WIDTH - 6 - 6 - 6, 15));
            connectWidget.getActions().addAction(ActionFactory.createConnectAction(connectionLayerWidget, new ConnectProvider() {

                public boolean isSourceWidget(Widget arg0) {
                    return true;
                }

                public ConnectorState isTargetWidget(Widget sourceWidgetChild, Widget targetWidget) {

                    if (targetWidget instanceof ChannelWidget) {
                        return ConnectorState.ACCEPT;
                    } else {
                        return ConnectorState.REJECT;
                    }
                }

                public boolean hasCustomTargetWidgetResolver(Scene arg0) {
                    return false;
                }

                public Widget resolveTargetWidget(Scene arg0, Point arg1) {
                    return null;
                }

                public void createConnection(Widget sourceWidgetChild, Widget targetWidget) {
                    try {
                        ComponentWidget srcNodeWidget = (ComponentWidget) sourceWidgetChild.getParentWidget();
                        ChannelWidget dstNodeWidget = (ChannelWidget) targetWidget;

                        ArrayList<String> handlers = new ArrayList<String>();
                        for (int i = 0; i < dstNodeWidget.getChannel().getEventClass().length; i++) {
                            if (dstNodeWidget.getChannel().getEventClass(i).length() > 0) {
                                handlers.add(dstNodeWidget.getChannel().getEventClass(i));
                            }
                        }

                        if (handlers.size() < 1) {
                            JOptionPane.showMessageDialog(null, "Please define one or more event classes in the channel first.");
                            return;
                        }

                        Icon icon = new ImageIcon(getClass().getResource("adl32.png"));

                        String eventClass = (String) JOptionPane.showInputDialog(null, "Choose event class:",
                                "Add binding",
                                JOptionPane.PLAIN_MESSAGE,
                                icon,
                                handlers.toArray(),
                                handlers.get(0));

                        // Completly new Node
                        Binding newBinding = new Binding();
                        newBinding.setChannelName(dstNodeWidget.getChannel().getChannelName());
                        newBinding.setComponentName(srcNodeWidget.getComponent().getFactoryName() + ":" + srcNodeWidget.getComponent().getComponentName());
                        newBinding.setEventClass(eventClass);
                        dObj.getConfiguration().getBindings().addBinding(newBinding);
                        dObj.modelUpdatedFromUI();
                        addBinding(newBinding, srcNodeWidget, dstNodeWidget);
                    } catch (IOException ex) {
                        Exceptions.printStackTrace(ex);
                    }
                }
            }));

            nodeMenuAction = ActionFactory.createPopupMenuAction(new PopupMenuProvider() {

                public JPopupMenu getPopupMenu(final Widget arg0, final Point arg1) {
                    return menu;
                }
            });
            this.getActions().addAction(nodeMenuAction);
        }

        public Component getComponent() {
            return node;
        }

        public boolean isEnabled(Widget w) {
            return w == componentWidget || w == factoryWidget;
        }

        @Override
        protected void notifyStateChanged(ObjectState arg0, ObjectState arg1) {

            System.out.println("stateChanged from " + arg0 + " to " + arg1);
        }

        public String getText(Widget w) {
            if (w == componentWidget) {
                return node.getComponentName();
            } else if (w == factoryWidget) {
                return node.getFactoryName();
            } else {
                return "strange"; // TODO
            }
        }

        public void setText(Widget w, String text) {
            LabelWidget l = (LabelWidget) w;
            if (w == componentWidget) {
                if (existsComponent(node.getFactoryName(), text)) {
                    return;
                }
                l.setLabel(text);
                refactorComponentName(node.getFactoryName(), node.getComponentName(), text);
            } else if (w == factoryWidget) {
                if (existsFactory(text)) {
                    return;
                }
                l.setLabel(text);
                refactorFactoryName(node.getFactoryName(), text);
            } else {
                System.out.println("strange");
            }
            dObj.modelUpdatedFromUI();
        }

        private void refactorFactoryName(String fromFactory, String toFactory) {
            try {
                // Change in Component
                node.setFactoryName(toFactory);

                // Change in Factory
                for (Factory f : dObj.getConfiguration().getFactories().getFactory()) {
                    if (f.getFactoryName().equals(fromFactory)) {
                        f.setFactoryName(toFactory);
                    }
                }

                // Update bindings
                for (Binding b : dObj.getConfiguration().getBindings().getBinding()) {
                    String[] name = b.getComponentName().split(":");
                    if (fromFactory.equals(name[0])) {
                        b.setComponentName(toFactory + ":" + name[1]);
                    }
                }

                // Update subscriptions
                for (Subscription b : dObj.getConfiguration().getSubscriptions().getSubscription()) {
                    String[] name = b.getComponentName().split(":");
                    if (fromFactory.equals(name[0])) {
                        b.setComponentName(toFactory + ":" + name[1]);
                    }
                }

                // Update start sequence
                for (int i = 0; i < dObj.getConfiguration().getStartSequence().getStartComponents().sizeComponentName(); i++) {
                    String[] name = dObj.getConfiguration().getStartSequence().getStartComponents().getComponentName(i).split(":");
                    if (fromFactory.equals(name[0])) {
                        dObj.getConfiguration().getStartSequence().getStartComponents().setComponentName(i, toFactory + ":" + name[1]);
                    }
                }
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }

        private void refactorComponentName(String factory, String fromComponentName, String toComponentName) {
            try {
                // Change in Component
                node.setComponentName(toComponentName);

                String fromFullName = factory + ":" + fromComponentName;
                String toFullName = factory + ":" + toComponentName;

                // Update bindings
                for (Binding b : dObj.getConfiguration().getBindings().getBinding()) {
                    if (b.getComponentName().equals(fromFullName)) {
                        b.setComponentName(toFullName);
                    }
                }

                // Update subscriptions
                for (Subscription b : dObj.getConfiguration().getSubscriptions().getSubscription()) {
                    if (b.getComponentName().equals(fromFullName)) {
                        b.setComponentName(toFullName);
                    }
                }

                // Update start sequence
                for (int i = 0; i < dObj.getConfiguration().getStartSequence().getStartComponents().sizeComponentName(); i++) {
                    if (dObj.getConfiguration().getStartSequence().getStartComponents().getComponentName(i).equals(fromFullName)) {
                        dObj.getConfiguration().getStartSequence().getStartComponents().setComponentName(i, toFullName);
                    }
                }

            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private boolean existsComponent(String factory, String component) {
        try {
            for (Component c : dObj.getConfiguration().getComponents().getComponent()) {
                if (c.getFactoryName().equals(factory) && c.getComponentName().equals(component)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private boolean existsChannel(String channel) {
        try {
            for (Channel c : dObj.getConfiguration().getChannels().getChannel()) {
                if (c.getChannelName().equals(channel)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private boolean existsFactory(String factory) {
        try {
            for (Factory c : dObj.getConfiguration().getFactories().getFactory()) {
                if (c.getFactoryName().equals(factory)) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private static String arrayToString(String[] array) {
        StringBuffer buff = new StringBuffer();
        for (String s : array) {
            if (s.length() > 0) {
                buff.append(s);
                buff.append(",");
            }
        }
        return buff.toString();
    }

    private static String[] stringToArray(String s) {
        return s.split(",");
    }

    private class ChannelWidget extends Widget implements TextFieldInplaceEditor {

        private Channel node;
        private LabelWidget channelWidget;
        private LabelWidget eventsWidget;
        private Widget connectWidget;
        private Border standardBorder = BorderFactory.createRoundedBorder(10, 10, 3, 3, new Color(255, 255, 0), Color.BLACK);
        private Border subBorder = BorderFactory.createRoundedBorder(10, 10, 3, 3, new Color(255, 255, 0), Color.GRAY);
        private static final int WIDTH = 200;
        private static final int HEIGHT = 80;
        private WidgetAction nodeMenuAction;
        private JPopupMenu menu;

        public ChannelWidget(Scene scene, Channel node) {
            super(scene);
            this.node = node;

            menu = new JPopupMenu("Channel popup menu");
            JMenuItem item;
            item = new JMenuItem("Add new channel");
            item.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    addChannelActionPerformed();
                }
            });
            menu.add(item);
            item = new JMenuItem("Remove channel");
            item.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    menuRemoveActionPerformed(ChannelWidget.this);
                }
            });
            menu.add(item);

            initWidget();
        }

        private void initWidget() {
            channelWidget = new LabelWidget(scene, node.getChannelName());
            eventsWidget = new LabelWidget(scene, arrayToString(node.getEventClass()));
            connectWidget = new Widget(scene);

            addChild(channelWidget);
            addChild(eventsWidget);
            addChild(connectWidget);

            setBorder(standardBorder);
            setPreferredSize(new Dimension(WIDTH, HEIGHT));
            getActions().addAction(ActionFactory.createMoveAction(new MoveStrategy() {

                public Point locationSuggested(Widget widget, Point originalLocation, Point suggestedLocation) {
                    return suggestedLocation;
                }
            }, new MoveProvider() {

                public void movementStarted(Widget arg0) {
                }

                public void movementFinished(Widget arg0) {
                    saveLocations();
                    dObj.modelUpdatedFromUI();
                }

                public Point getOriginalLocation(Widget arg0) {
                    return arg0.getLocation();
                }

                public void setNewLocation(Widget arg0, Point arg1) {
                    arg0.setPreferredLocation(arg1);
                }
            }));

            //channelWidget.setBorder(subBorder);
            channelWidget.setPreferredLocation(new Point(0, 20));
            channelWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            channelWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            //eventsWidget.setBorder(subBorder);
            eventsWidget.setPreferredLocation(new Point(0, 40));
            eventsWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            eventsWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            connectWidget.setBorder(subBorder);
            connectWidget.setPreferredLocation(new Point(6, 60));
            connectWidget.setPreferredSize(new Dimension(WIDTH - 6 - 6 - 6, 15));
            connectWidget.getActions().addAction(ActionFactory.createConnectAction(connectionLayerWidget, new ConnectProvider() {

                public boolean isSourceWidget(Widget arg0) {
                    return true;
                }

                public ConnectorState isTargetWidget(Widget sourceWidgetChild, Widget targetWidget) {

                    if (targetWidget instanceof ComponentWidget) {
                        return ConnectorState.ACCEPT;
                    } else {
                        return ConnectorState.REJECT;
                    }
                }

                public boolean hasCustomTargetWidgetResolver(Scene arg0) {
                    return false;
                }

                public Widget resolveTargetWidget(Scene arg0, Point arg1) {
                    return null;
                }

                public void createConnection(Widget sourceWidgetChild, Widget targetWidget) {
                    try {
                        ChannelWidget srcNodeWidget = (ChannelWidget) sourceWidgetChild.getParentWidget();
                        ComponentWidget dstNodeWidget = (ComponentWidget) targetWidget;

                        ArrayList<String> handlers = new ArrayList<String>();
                        for (int i = 0; i < srcNodeWidget.getChannel().getEventClass().length; i++) {
                            if (srcNodeWidget.getChannel().getEventClass(i).length() > 0) {
                                handlers.add(createHandlerName(srcNodeWidget.getChannel().getEventClass(i)));
                            }
                        }

                        if (handlers.size() < 1) {
                            JOptionPane.showMessageDialog(null, "Please define one or more event classes in the channel first.");
                            return;
                        }

                        Icon icon = new ImageIcon(getClass().getResource("adl32.png"));

                        String handlerName = (String) JOptionPane.showInputDialog(null, "Choose handler method:",
                                "Add subscription",
                                JOptionPane.PLAIN_MESSAGE,
                                icon,
                                handlers.toArray(),
                                handlers.get(0));

                        if (handlerName != null) {

                            // Completly new Node
                            Subscription newSubscription = new Subscription();
                            newSubscription.setChannelName(srcNodeWidget.getChannel().getChannelName());
                            newSubscription.setComponentName(dstNodeWidget.getComponent().getFactoryName() + ":" + dstNodeWidget.getComponent().getComponentName());
                            newSubscription.setHandlerName(handlerName);
                            dObj.getConfiguration().getSubscriptions().addSubscription(newSubscription);
                            dObj.modelUpdatedFromUI();
                            addSubscription(newSubscription, srcNodeWidget, dstNodeWidget);
                        }
                    } catch (IOException ex) {
                        Exceptions.printStackTrace(ex);
                    }
                }

                private String createHandlerName(String className) {
                    if (className.indexOf(".") != -1) {
                        return "handle" + className.substring(className.lastIndexOf(".") + 1, className.length());
                    } else {
                        return "handle" + className;
                    }
                }
            }));

            nodeMenuAction = ActionFactory.createPopupMenuAction(new PopupMenuProvider() {

                public JPopupMenu getPopupMenu(final Widget arg0, final Point arg1) {
                    return menu;
                }
            });
            this.getActions().addAction(nodeMenuAction);
        }

        @Override
        protected void notifyStateChanged(ObjectState arg0, ObjectState arg1) {

            System.out.println("stateChanged from " + arg0 + " to " + arg1);
        }

        public Channel getChannel() {
            return node;
        }

        public boolean isEnabled(Widget w) {
            return w == channelWidget || w == eventsWidget;
        }

        public String getText(Widget w) {
            if (w == channelWidget) {
                return node.getChannelName();
            } else if (w == eventsWidget) {
                return arrayToString(node.getEventClass());
            } else {
                return "strange"; // TODO
            }
        }

        public void setText(Widget w, String text) {
            LabelWidget l = (LabelWidget) w;
            if (w == channelWidget) {
                // Check so there does not exist another channel with that name!
                if (channelNameExists(text)) {
                    return;
                }
                l.setLabel(text);
                refactorChannelName(node.getChannelName(), text); //node.setChannelName(text);
            } else if (w == eventsWidget) {
                l.setLabel(text);
                node.setEventClass(stringToArray(text));
            } else {
                System.out.println("strange");
            }
            dObj.modelUpdatedFromUI();
        }

        private boolean channelNameExists(String channelName) {
            try {
                for (Channel c : dObj.getConfiguration().getChannels().getChannel()) {
                    if (c.getChannelName().equals(channelName)) {
                        return true;
                    }
                }
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
            return false;
        }

        private void refactorChannelName(String fromChannelName, String toChannelName) { // TODO handle in a transaction?
            try {
                // Update channel:channelName
                node.setChannelName(toChannelName);

                // Update bindings
                for (Binding b : dObj.getConfiguration().getBindings().getBinding()) {
                    if (b.getChannelName().equals(fromChannelName)) {
                        b.setChannelName(toChannelName);
                    }
                }

                // Update subscriptions
                for (Subscription b : dObj.getConfiguration().getSubscriptions().getSubscription()) {
                    if (b.getChannelName().equals(fromChannelName)) {
                        b.setChannelName(toChannelName);
                    }
                }

                // Update start sequence
                for (int i = 0; i < dObj.getConfiguration().getStartSequence().getStartChannels().sizeChannelName(); i++) {
                    if (dObj.getConfiguration().getStartSequence().getStartChannels().getChannelName(i).equals(fromChannelName)) {
                        dObj.getConfiguration().getStartSequence().getStartChannels().setChannelName(i, toChannelName);
                    }
                }
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private class SubscriptionWidget extends LabelWidget implements TextFieldInplaceEditor {

        private Subscription link;
        private ChannelWidget srcChannelWidget;
        private ComponentWidget dstComponentWidget;
        private static final int WIDTH = 130;
        private static final int HEIGHT = 20;
        private WidgetAction menuAction;
        private JPopupMenu menu;
        private JMenuItem menuItemRemove;

        public SubscriptionWidget(Scene scene, Subscription link, ChannelWidget srcChannelWidget, ComponentWidget dstComponentWidget) {
            super(scene);
            this.link = link;
            this.srcChannelWidget = srcChannelWidget;
            this.dstComponentWidget = dstComponentWidget;

            menu = new JPopupMenu("Subscription menu");

            menuItemRemove = new JMenuItem("Remove subscription");
            menuItemRemove.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    menuRemoveActionPerformed(SubscriptionWidget.this);
                }
            });
            menu.add(menuItemRemove);

            initWidget();
        }

        private void initWidget() {
            setLabel(link.getHandlerName());

            setPreferredSize(new Dimension(WIDTH, HEIGHT));

            this.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            menuAction = ActionFactory.createPopupMenuAction(new PopupMenuProvider() {

                public JPopupMenu getPopupMenu(final Widget arg0, final Point arg1) {
                    return menu;
                }
            });
            this.getActions().addAction(menuAction);
        }

        public Subscription getSubscription() {
            return link;
        }

        public boolean isEnabled(Widget w) {
            return w == this;
        }

        public String getText(Widget w) {
            if (w == this) {
                return link.getHandlerName();
            } else {
                return "strange"; // TODO
            }
        }

        public void setText(Widget w, String text) {
            LabelWidget l = (LabelWidget) w;
            if (w == this) {
                l.setLabel(text);
                link.setHandlerName(text);
            } else {
                System.out.println("strange");
            }
            dObj.modelUpdatedFromUI();
        }
    }

    private class BindingWidget extends LabelWidget implements TextFieldInplaceEditor {

        private Binding link;
        private ComponentWidget srcComponentWidget;
        private ChannelWidget dstChannelWidget;
        private static final int WIDTH = 130;
        private static final int HEIGHT = 20;
        private WidgetAction menuAction;
        private JPopupMenu menu;
        private JMenuItem menuItemRemove;

        public BindingWidget(Scene scene, Binding link, ComponentWidget srcComponentWidget, ChannelWidget dstChannelWidget) {
            super(scene);
            this.link = link;
            this.srcComponentWidget = srcComponentWidget;
            this.dstChannelWidget = dstChannelWidget;

            menu = new JPopupMenu("Binding menu");
            menuItemRemove = new JMenuItem("Remove binding");
            menuItemRemove.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    menuRemoveActionPerformed(BindingWidget.this);
                }
            });
            menu.add(menuItemRemove);

            initWidget();
        }

        private void initWidget() {
            setLabel(link.getEventClass());

            setPreferredSize(new Dimension(WIDTH, HEIGHT));

            this.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            menuAction = ActionFactory.createPopupMenuAction(new PopupMenuProvider() {

                public JPopupMenu getPopupMenu(final Widget arg0, final Point arg1) {
                    return menu;
                }
            });
            this.getActions().addAction(menuAction);
        }

        public Binding getBinding() {
            return link;
        }

        public boolean isEnabled(Widget w) {
            return w == this;
        }

        public String getText(Widget w) {
            if (w == this) {
                return link.getEventClass();
            } else {
                return "strange"; // TODO
            }
        }

        public void setText(Widget w, String text) {
            LabelWidget l = (LabelWidget) w;
            if (w == this) {
                l.setLabel(text);
                link.setEventClass(text);
            } else {
                System.out.println("strange");
            }
            dObj.modelUpdatedFromUI();
        }
    }
}