/*
 * GraphTopologyPanel.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.topology;

import com.markuspage.markus.tbn.module1.AbstractTopMultiViewPanel;
import com.markuspage.markus.tbn.module1.CommentUtils;
import com.markuspage.markus.tbn.module1.topology.model.Link;
import com.markuspage.markus.tbn.module1.topology.model.Node;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.JComponent;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import org.netbeans.api.visual.action.ActionFactory;
import org.netbeans.api.visual.action.ConnectProvider;
import org.netbeans.api.visual.action.ConnectorState;
import org.netbeans.api.visual.action.MoveProvider;
import org.netbeans.api.visual.action.MoveStrategy;
import org.netbeans.api.visual.action.PopupMenuProvider;
import org.netbeans.api.visual.action.TextFieldInplaceEditor;
import org.netbeans.api.visual.action.WidgetAction;
import org.netbeans.api.visual.anchor.AnchorFactory;
import org.netbeans.api.visual.anchor.AnchorShapeFactory;
import org.netbeans.api.visual.border.Border;
import org.netbeans.api.visual.border.BorderFactory;
import org.netbeans.api.visual.layout.LayoutFactory;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LabelWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.Widget;
import org.openide.util.Exceptions;

/**
 *
 * @author  markus
 */
public class GraphTopologyPanel extends AbstractTopMultiViewPanel {

    private TopologyDataObject dObj;
    private Scene scene = new Scene();
    private int x = 20,  y = 130;
    private LayerWidget mainLayerWidget;
    private LayerWidget connectionLayerWidget;

    public GraphTopologyPanel(TopologyDataObject dObj) {
        this.dObj = dObj;
        initComponents();
    //initScene();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jToolBar1 = new javax.swing.JToolBar();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jButtonAddNode = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jButtonZoomOut = new javax.swing.JButton();
        jButtonZoomIn = new javax.swing.JButton();
        graphPane = new javax.swing.JScrollPane();

        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);
        jToolBar1.add(jSeparator1);

        jButtonAddNode.setText(org.openide.util.NbBundle.getMessage(GraphTopologyPanel.class, "GraphTopologyPanel.jButtonAddNode.text")); // NOI18N
        jButtonAddNode.setFocusable(false);
        jButtonAddNode.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonAddNode.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonAddNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddNodeActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonAddNode);
        jToolBar1.add(jSeparator2);

        jButtonZoomOut.setText(org.openide.util.NbBundle.getMessage(GraphTopologyPanel.class, "GraphTopologyPanel.jButtonZoomOut.text")); // NOI18N
        jButtonZoomOut.setFocusable(false);
        jButtonZoomOut.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonZoomOut.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonZoomOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomOutActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonZoomOut);

        jButtonZoomIn.setText(org.openide.util.NbBundle.getMessage(GraphTopologyPanel.class, "GraphTopologyPanel.jButtonZoomIn.text")); // NOI18N
        jButtonZoomIn.setFocusable(false);
        jButtonZoomIn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonZoomIn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonZoomIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonZoomInActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonZoomIn);

        graphPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(graphPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 569, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(graphPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 422, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    private void jButtonAddNodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddNodeActionPerformed
        addActionPerformed();
    }//GEN-LAST:event_jButtonAddNodeActionPerformed

    private void jButtonZoomInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomInActionPerformed
        try {
            scene.setZoomFactor(scene.getZoomFactor() + 0.1);
            scene.validate();
            CommentUtils.saveZoomFactor(dObj.getTopology(), scene.getZoomFactor());
            dObj.modelUpdatedFromUI();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_jButtonZoomInActionPerformed

    private void jButtonZoomOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonZoomOutActionPerformed
        try {
            double zoom = scene.getZoomFactor() - 0.1;
            if (zoom < 0.1) {
                zoom = 0.1;
            }
            scene.setZoomFactor(zoom);
            scene.validate();
            CommentUtils.saveZoomFactor(dObj.getTopology(), zoom);
            dObj.modelUpdatedFromUI();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_jButtonZoomOutActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JScrollPane graphPane;
    private javax.swing.JButton jButtonAddNode;
    private javax.swing.JButton jButtonZoomIn;
    private javax.swing.JButton jButtonZoomOut;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
    

    private void initScene() {
        scene = new Scene();
        scene.setLayout(LayoutFactory.createAbsoluteLayout());
        mainLayerWidget = new LayerWidget(scene);
        scene.addChild(mainLayerWidget);
        connectionLayerWidget = new LayerWidget(scene);
        scene.addChild(connectionLayerWidget);

        scene.getActions().addAction(ActionFactory.createZoomAction());

        try {
            Double zoom = CommentUtils.getZoomFactor(dObj.getTopology());
            if (zoom == null) {
                zoom = 1.0;
            }
            scene.setZoomFactor(zoom);
        } catch (IOException ex) {
            ex.printStackTrace();
        }

        // Add all nodes
        try {
            for (Node node : dObj.getTopology().getNodes().getNode()) {
                addNodeToScene(node);
            }
            graphPane.setViewportView(scene.createView());
        } catch (IOException ex) {
            ex.printStackTrace();
        }

        // Setup all links
        try {
            for (Link link : dObj.getTopology().getLinks().getLink()) {

                String srcId = link.getAttributeValue("src_id");
                String dstId = link.getAttributeValue("dst_id");

                NodeWidget wSrcId = findWidgetByNodeId(srcId);
                NodeWidget wDstId = findWidgetByNodeId(dstId);

                addLink(link, wSrcId, wDstId);
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private void addActionPerformed() {

        String nodeId = JOptionPane.showInputDialog("New node ID:");

        if (existsNode(nodeId)) {
            System.out.println("Node already exists");
            return;
        }

        Node newNode = new Node();
        newNode.setAttributeValue("id", nodeId);

        try {
            dObj.getTopology().getNodes().addNode(newNode);

            // Update node numbers
            dObj.getTopology().getNodes().setAttributeValue("number", "" + dObj.getTopology().getNodes().sizeNode());
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        dObj.modelUpdatedFromUI();

        Widget newWidget = addNodeToScene(newNode);
        scene.validate();
        newWidget.repaint();
    }

    private boolean existsNode(String id) {
        try {
            for (Node c : dObj.getTopology().getNodes().getNode()) {
                if (id.equals(c.getAttributeValue("id"))) {
                    return true;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return false;
    }

    private void menuRemoveActionPerformed(Widget widget) {
        System.out.println("Remove " + widget);

        if (widget instanceof NodeWidget) {
            NodeWidget l = (NodeWidget) widget;
            Node removeNode = l.getNode();
            try {
                dObj.getTopology().getNodes().removeNode(removeNode);

                // Update node numbers
                dObj.getTopology().getNodes().setAttributeValue("number", "" + dObj.getTopology().getNodes().sizeNode());

                dObj.modelUpdatedFromUI();
                mainLayerWidget.removeChild(widget);
                scene.validate();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        } else if (widget instanceof LinkWidget) {
            LinkWidget l = (LinkWidget) widget;
            Link removeLink = l.getLink();
            try {
                dObj.getTopology().getLinks().removeLink(removeLink);
                dObj.modelUpdatedFromUI();
                System.out.println("LinkWidget: " + l);
                System.out.println("Parent: " + l.getParentWidget());
                connectionLayerWidget.removeChild(l.getParentWidget());
                scene.validate();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private Widget addNodeToScene(Node node) {

        NodeWidget nodeWidget = new NodeWidget(scene, node);

        // Set location
        Point location = CommentUtils.getLocation(node);
        if (location != null) {
            nodeWidget.setPreferredLocation(location);
        } else {
            nodeWidget.setPreferredLocation(new Point(x, y));
        }

        mainLayerWidget.addChild(nodeWidget);

        // Update for next position
        x += 150;
        y += 20;
        if (x > 400 && x <= 590) {
            x += 150;
        }
        if (x >= 670) {
            y += 80;
            x = 20;
        }
        return nodeWidget;
    }

    private void addLink(Link link, NodeWidget wSrcId, NodeWidget wDstId) {
        ConnectionWidget connectionWidget = new ConnectionWidget(scene);
        connectionWidget.setSourceAnchor(AnchorFactory.createRectangularAnchor(wSrcId));
        connectionWidget.setTargetAnchor(AnchorFactory.createRectangularAnchor(wDstId));
        connectionWidget.setTargetAnchorShape(AnchorShapeFactory.createArrowAnchorShape(40, 10));
        if ("true".equals(link.getAttributeValue("undirected"))) {
            connectionWidget.setSourceAnchorShape(AnchorShapeFactory.createArrowAnchorShape(40, 10));
        }
        LinkWidget label = new LinkWidget(scene, link, wSrcId, wDstId);
        connectionWidget.addChild(label);
        connectionWidget.setConstraint(label, LayoutFactory.ConnectionWidgetLayoutAlignment.CENTER, 50);
        connectionLayerWidget.addChild(connectionWidget);
        scene.validate();
    }

    private NodeWidget findWidgetByNodeId(String id) {

        for (Widget w : mainLayerWidget.getChildren()) {

            if (w instanceof NodeWidget) {
                NodeWidget n = (NodeWidget) w;
                if (id.equals(n.getNode().getAttributeValue("id"))) {
                    return n;
                }
            }
        }
        System.out.println("null");
        return null;
    }

    private class SceneConnectProvider implements ConnectProvider {

        private String source = null;
        private String target = null;

        public boolean isSourceWidget(Widget sourceWidget) {
            /*Object object = findObject (sourceWidget);
            source = isNode (object) ? (String) object : null;
            return source != null;*/
            return true;
        }

        public ConnectorState isTargetWidget(Widget sourceWidget, Widget targetWidget) {
            /*Object object = findObject (targetWidget);
            target = isNode (object) ? (String) object : null;
            if (target != null)
            return ! source.equals (target) ? ConnectorState.ACCEPT : ConnectorState.REJECT_AND_STOP;
            return object != null ? ConnectorState.REJECT_AND_STOP : ConnectorState.REJECT;*/

            /*if(targetWidget == mainLayerWidget || sourceWidget == mainLayerWidget) {
            return ConnectorState.REJECT;
            }*/

            if (targetWidget instanceof NodeWidget && targetWidget != sourceWidget.getParentWidget()) {
                return ConnectorState.ACCEPT;
            } else {
                return ConnectorState.REJECT;
            }
        }

        public boolean hasCustomTargetWidgetResolver(Scene scene) {
            return false;
        }

        public Widget resolveTargetWidget(Scene scene, Point sceneLocation) {
            return null;
        }

        public void createConnection(Widget sourceWidget, Widget targetWidget) {
            try {
                NodeWidget srcNodeWidget = (NodeWidget) sourceWidget.getParentWidget();
                NodeWidget dstNodeWidget = (NodeWidget) targetWidget;

                // Find existing link in opposit direction
                Link otherLink = findLink(dstNodeWidget.getNode().getAttributeValue("id"), srcNodeWidget.getNode().getAttributeValue("id"));
                if (otherLink != null) {
                    otherLink.setAttributeValue("undirected", "true");
                    dObj.modelUpdatedFromUI();
                    addLink(otherLink, srcNodeWidget, dstNodeWidget);
                    return;
                }

                // Find existing link in same direction
                otherLink = findLink(srcNodeWidget.getNode().getAttributeValue("id"), dstNodeWidget.getNode().getAttributeValue("id"));
                if (otherLink != null) {
                    // Nothing to do
                    return;
                }

                // Completly new Node
                Link newLink = new Link();
                newLink.setAttributeValue("dst_id", dstNodeWidget.getNode().getAttributeValue("id"));
                newLink.setAttributeValue("src_id", srcNodeWidget.getNode().getAttributeValue("id"));
                dObj.getTopology().getLinks().addLink(newLink);
                dObj.modelUpdatedFromUI();
                addLink(newLink, srcNodeWidget, dstNodeWidget);
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private Link findLink(String srcId, String dstId) {
        try {
            for (Link otherLink : dObj.getTopology().getLinks().getLink()) {
                if (srcId.equals(otherLink.getAttributeValue("src_id")) && dstId.equals(otherLink.getAttributeValue("dst_id"))) {
                    return otherLink;
                }
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
        return null;
    }

    private void saveLocations() {
        for (Widget w : mainLayerWidget.getChildren()) {
            if (w instanceof NodeWidget) {
                NodeWidget c = (NodeWidget) w;
                CommentUtils.saveLocation(c.getNode(), c.getLocation());
            }
        }
    }

    private class NodeWidget extends Widget implements TextFieldInplaceEditor {

        private Node node;
        private LabelWidget idWidget;
        private LabelWidget ipWidget;
        private LabelWidget portWidget;
        private Widget connectWidget;
        private Border standardBorder = BorderFactory.createRoundedBorder(10, 10, 3, 3, new Color(255, 255, 153), Color.BLACK);
        private Border subBorder = BorderFactory.createRoundedBorder(10, 10, 3, 3, new Color(235, 235, 123), Color.GRAY);
        private static final int WIDTH = 100;
        private static final int HEIGHT = 100;
        private WidgetAction nodeMenuAction;
        private JPopupMenu menu;

        public NodeWidget(Scene scene, Node node) {
            super(scene);
            this.node = node;

            menu = new JPopupMenu("Node popup menu");
            JMenuItem item;
            item = new JMenuItem("Add new node");
            item.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    addActionPerformed();
                }
            });
            menu.add(item);
            item = new JMenuItem("Remove node");
            item.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    menuRemoveActionPerformed(NodeWidget.this);
                }
            });
            menu.add(item);

            initWidget();
        }

        private void initWidget() {
            idWidget = new LabelWidget(scene, "Node " + node.getAttributeValue("id"));
            ipWidget = new LabelWidget(scene, node.getAttributeValue("ip"));
            portWidget = new LabelWidget(scene, node.getAttributeValue("port"));
            connectWidget = new Widget(scene);

            addChild(idWidget);
            addChild(ipWidget);
            addChild(portWidget);
            addChild(connectWidget);

            setBorder(standardBorder);
            setPreferredSize(new Dimension(WIDTH, HEIGHT));
            //getActions().addAction(ActionFactory.createMoveAction());
            getActions().addAction(ActionFactory.createMoveAction(new MoveStrategy() {

                public Point locationSuggested(Widget widget, Point originalLocation, Point suggestedLocation) {
                    return suggestedLocation;
                }
            }, new MoveProvider() {

                public void movementStarted(Widget arg0) {
                }

                public void movementFinished(Widget arg0) {
                    saveLocations();
                    dObj.modelUpdatedFromUI();
                }

                public Point getOriginalLocation(Widget arg0) {
                    return arg0.getLocation();
                }

                public void setNewLocation(Widget arg0, Point arg1) {
                    arg0.setPreferredLocation(arg1);
                }
            }));

            idWidget.setBorder(subBorder);
            idWidget.setPreferredLocation(new Point(0, 20));
            idWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            idWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            ipWidget.setBorder(subBorder);
            ipWidget.setPreferredLocation(new Point(0, 40));
            ipWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            ipWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            portWidget.setBorder(subBorder);
            portWidget.setPreferredLocation(new Point(0, 60));
            portWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            portWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            connectWidget.setBorder(subBorder);
            connectWidget.setPreferredLocation(new Point(0, 80));
            connectWidget.setPreferredSize(new Dimension(95, 15));
            connectWidget.getActions().addAction(ActionFactory.createConnectAction(connectionLayerWidget, new SceneConnectProvider()));

            nodeMenuAction = ActionFactory.createPopupMenuAction(new PopupMenuProvider() {

                public JPopupMenu getPopupMenu(final Widget arg0, final Point arg1) {
                    return menu;
                }
            });
            this.getActions().addAction(nodeMenuAction);
        }

        public Node getNode() {
            return node;
        }

        public boolean isEnabled(Widget w) {
            return w == idWidget || w == ipWidget || w == portWidget;
        }

        public String getText(Widget w) {
            if (w == idWidget) {
                return node.getAttributeValue("id");
            } else if (w == ipWidget) {
                return node.getAttributeValue("ip");
            } else if (w == portWidget) {
                return node.getAttributeValue("port");
            } else {
                return "strange"; // TODO
            }
        }

        public void setText(Widget w, String text) {
            LabelWidget l = (LabelWidget) w;
            if (w == idWidget) {
                // Check so there does not exist another node with that name!
                if (existsNode(text)) {
                    return;
                }
                l.setLabel("Node " + text);
                refactorNodeId(node.getAttributeValue("id"), text);

            } else if (w == ipWidget) {
                l.setLabel(text);
                node.setAttributeValue("ip", text);
            } else if (w == portWidget) {
                l.setLabel(text);
                node.setAttributeValue("port", text);
            } else {
                System.out.println("strange");
            }
            dObj.modelUpdatedFromUI();
        }

        private void refactorNodeId(String fromId, String toId) { // TODO handle in a transaction?
            try {
                // Update 
                node.setAttributeValue("id", toId);

                // Update links
                for (Link b : dObj.getTopology().getLinks().getLink()) {
                    if (fromId.equals(b.getAttributeValue("src_id"))) {
                        b.setAttributeValue("src_id", toId);
                    }
                    if (fromId.equals(b.getAttributeValue("dst_id"))) {
                        b.setAttributeValue("dst_id", toId);
                    }
                }
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private class LinkWidget extends Widget implements TextFieldInplaceEditor {

        private Link link;
        private NodeWidget srcWidget;
        private NodeWidget dstWidget;
        private LabelWidget latencyWidget;
        private LabelWidget lossWidget;
        private Border subBorder = BorderFactory.createRoundedBorder(10, 10, 3, 3, new Color(255, 233, 255), Color.LIGHT_GRAY);
        private static final int WIDTH = 70;
        private static final int HEIGHT = 50;
        private WidgetAction menuAction;
        private JPopupMenu menu;
        private JMenuItem menuItemUndirected;
        private JMenuItem menuItemRemove;
        private JMenuItem menuItemOnly1;
        private JMenuItem menuItemOnly2;

        public LinkWidget(Scene scene, Link link, NodeWidget srcWidget, NodeWidget dstWidget) {
            super(scene);
            this.link = link;
            this.srcWidget = srcWidget;
            this.dstWidget = dstWidget;

            menu = new JPopupMenu("Link menu");

            menuItemUndirected = new JMenuItem("Make undirected");
            menuItemUndirected.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    undirectedActionPerformed();
                }
            });
            menu.add(menuItemUndirected);
            menuItemOnly1 = new JMenuItem("Make only to node " + link.getAttributeValue("src_id"));
            menuItemOnly1.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    onlySrcActionPerformed();
                }
            });
            menu.add(menuItemOnly1);
            menuItemOnly2 = new JMenuItem("Make only to node " + link.getAttributeValue("dst_id"));
            menuItemOnly2.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    onlyDstActionPerformed();
                }
            });
            menu.add(menuItemOnly2);
            menuItemRemove = new JMenuItem("Remove");
            menuItemRemove.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    menuRemoveActionPerformed(LinkWidget.this);
                }
            });
            menu.add(menuItemRemove);

            initWidget();
        }

        private void initWidget() {
            latencyWidget = new LabelWidget(scene, link.getAttributeValue("latency") + " ms");
            lossWidget = new LabelWidget(scene, link.getAttributeValue("loss_rate"));

            addChild(latencyWidget);
            addChild(lossWidget);

            setPreferredSize(new Dimension(WIDTH, HEIGHT));

            latencyWidget.setBorder(subBorder);
            latencyWidget.setPreferredLocation(new Point(0, 0));
            latencyWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            latencyWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            lossWidget.setBorder(subBorder);
            lossWidget.setPreferredLocation(new Point(0, 20));
            lossWidget.setPreferredSize(new Dimension(WIDTH - 5, 20));
            lossWidget.getActions().addAction(ActionFactory.createInplaceEditorAction(this));

            menuAction = ActionFactory.createPopupMenuAction(new PopupMenuProvider() {

                public JPopupMenu getPopupMenu(final Widget arg0, final Point arg1) {
                    return menu;
                }
            });
            this.getActions().addAction(menuAction);
        }

        public Link getLink() {
            return link;
        }

        public boolean isEnabled(Widget w) {
            return w == latencyWidget || w == lossWidget;
        }

        public String getText(Widget w) {
            if (w == latencyWidget) {
                return link.getAttributeValue("latency");
            } else if (w == lossWidget) {
                return link.getAttributeValue("loss_rate");
            } else {
                return "strange"; // TODO
            }
        }

        public void setText(Widget w, String text) {
            LabelWidget l = (LabelWidget) w;
            if (w == latencyWidget) {
                l.setLabel(text + " ms");
                link.setAttributeValue("latency", text);
            } else if (w == lossWidget) {
                l.setLabel(text);
                link.setAttributeValue("loss_rate", text);
            } else {
                System.out.println("strange");
            }
            dObj.modelUpdatedFromUI();
        }

        private void undirectedActionPerformed() {
            link.setAttributeValue("undirected", "true");
            dObj.modelUpdatedFromUI();
            addLink(link, srcWidget, dstWidget);
        }

        private void onlySrcActionPerformed() {
            link.setAttributeValue("undirected", "false");
            String src = link.getAttributeValue("src_id");
            link.setAttributeValue("src_id", link.getAttributeValue("dst_id"));
            link.setAttributeValue("dst_id", src);
            dObj.modelUpdatedFromUI();
            connectionLayerWidget.removeChild(getParentWidget());
            addLink(link, dstWidget, srcWidget);
        }

        private void onlyDstActionPerformed() {
            link.setAttributeValue("undirected", "false");
            dObj.modelUpdatedFromUI();
            connectionLayerWidget.removeChild(getParentWidget());
            addLink(link, dstWidget, srcWidget);
        }
    }

    @Override
    public JComponent getToolbarComponent() {
        return jToolBar1;
    }

    @Override
    public void reload() {
        initScene();
    }
}
