/*
 * LinkPanel.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.topology;

import com.markuspage.markus.tbn.module1.topology.model.*;

import javax.swing.JComponent;
import javax.swing.text.JTextComponent;
import org.netbeans.modules.xml.multiview.ui.SectionInnerPanel;
import org.netbeans.modules.xml.multiview.ui.SectionView;

/**
 *
 * @author  markus
 */
public class LinkPanel extends SectionInnerPanel {

    Link factory;
    TopologyDataObject dObj;
    
    public LinkPanel(SectionView view, TopologyDataObject dObj, Link factory) {
        super(view);
        this.dObj=dObj;
        this.factory=factory;
        initComponents();
        
        jTextFieldSrcId.setText(factory.getAttributeValue("src_id"));
        addValidatee(jTextFieldSrcId);
        jTextFieldDstId.setText(factory.getAttributeValue("dst_id"));
        addValidatee(jTextFieldDstId);
        jCheckBoxUndirected.setSelected("true".equals(factory.getAttributeValue("undirected")));
        jTextFieldLatency.setText(factory.getAttributeValue("latency"));
        addValidatee(jTextFieldLatency);
        jTextFieldLoss.setText(factory.getAttributeValue("loss_rate"));
        addValidatee(jTextFieldLoss);
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldSrcId = new javax.swing.JTextField();
        jTextFieldDstId = new javax.swing.JTextField();
        jCheckBoxUndirected = new javax.swing.JCheckBox();
        jTextFieldLatency = new javax.swing.JTextField();
        jTextFieldLoss = new javax.swing.JTextField();

        jLabel1.setText(org.openide.util.NbBundle.getMessage(LinkPanel.class, "LinkPanel.jLabel1.text")); // NOI18N

        jCheckBoxUndirected.setText(org.openide.util.NbBundle.getMessage(LinkPanel.class, "LinkPanel.jCheckBoxUndirected.text")); // NOI18N
        jCheckBoxUndirected.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxUndirectedActionPerformed(evt);
            }
        });

        jTextFieldLoss.setText(org.openide.util.NbBundle.getMessage(LinkPanel.class, "LinkPanel.jTextFieldLoss.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jTextFieldLatency, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldSrcId, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldDstId, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jCheckBoxUndirected, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldLoss, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldSrcId, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldDstId, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jCheckBoxUndirected)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldLatency, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldLoss, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(new java.awt.Component[] {jTextFieldDstId, jTextFieldLatency, jTextFieldSrcId}, org.jdesktop.layout.GroupLayout.VERTICAL);

    }// </editor-fold>//GEN-END:initComponents

    private void jCheckBoxUndirectedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxUndirectedActionPerformed
        factory.setAttributeValue("undirected", jCheckBoxUndirected.isSelected() ? "true" : "false");
        dObj.modelUpdatedFromUI();
    }//GEN-LAST:event_jCheckBoxUndirectedActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBoxUndirected;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextFieldDstId;
    private javax.swing.JTextField jTextFieldLatency;
    private javax.swing.JTextField jTextFieldLoss;
    private javax.swing.JTextField jTextFieldSrcId;
    // End of variables declaration//GEN-END:variables

    @Override
    public void setValue(JComponent source, Object value) {
        
        if(source == jTextFieldSrcId) {
            factory.setAttributeValue("src_id", (String)value);
        } else if(source == jTextFieldDstId) {
            factory.setAttributeValue("dst_id", (String)value);
        } else if(source == jCheckBoxUndirected) {
            factory.setAttributeValue("undirected", jCheckBoxUndirected.isSelected() ? "true" : "false");
        } else if(source == jTextFieldLatency) {
            factory.setAttributeValue("latency", (String)value);
        } else if(source == jTextFieldLoss) {
            factory.setAttributeValue("loss_rate", (String)value);
        }
    }

    @Override
    public void documentChanged(JTextComponent comp, String value) {
        
      /* TODO if(comp == jTextFieldName) {
            String val = (String)value;
            if(val.length() == 0) {
                getSectionView().getErrorPanel().setError(new org.netbeans.modules.xml.multiview.Error(org.netbeans.modules.xml.multiview.Error.MISSING_VALUE_MESSAGE, "name", comp));
                return;
            }
            getSectionView().getErrorPanel().clearError();
        }*/
        
        // TODO componentClass?
    }

    @Override
    public void rollbackValue(JTextComponent source) {

        if(source == jTextFieldSrcId) {
            jTextFieldSrcId.setText(factory.getAttributeValue("src_id"));
        } else if(source == jTextFieldDstId) {
            jTextFieldDstId.setText(factory.getAttributeValue("dst_id"));
        } /*else if(source == jCheckBoxUndirected) {
            factory.setAttributeValue("undirected", jCheckBoxUndirected.isSelected() ? "true" : "false");
        }*/ else if(source == jTextFieldLatency) {
            jTextFieldLatency.setText(factory.getAttributeValue("latency"));
        } else if(source == jTextFieldLoss) {
            jTextFieldLatency.setText(factory.getAttributeValue("loss_rate"));
        }
        
        /* TODO
        if(source == jTextFieldName) {
            jTextFieldName.setText(factory.getFactoryName());
        }*/
        
        // TODO componentClass?
    }

    /*@Override
    protected void signalUIChange() {
        dObj.modelUpdatedFromUI();
    }*/
    
    public void linkButtonPressed(Object arg0, String arg1) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public JComponent getErrorComponent(String errorId) {
        /* TODO if ("name".equals(errorId)) {
            return jTextFieldName;
        }*/
        // TODO componentClass?
        
        return null;
    }
    
}
